<?php
// AShop
// Copyright 2012 - AShop Software - http://www.ashopsoftware.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see: http://www.gnu.org/licenses/.

include "admin/config.inc.php";
include "admin/ashopconstants.inc.php";
include "admin/ashopfunc.inc.php";

// Initialize variables...
if (!isset($lang)) $lang = "";
if (!isset($price)) $price = "";
if (!isset($displaylicenseerror)) $displaylicenseerror = FALSE;
if (!isset($license)) $license = "";
if (!isset($discountcookiestring)) $discountcookiestring = "";
if (!isset($p3psent)) $p3psent = FALSE;
if (!ashop_is_url($redirect)) $redirect = "";
$redirect = str_ireplace("http://","",$redirect);
$redirect = str_ireplace("https://","",$redirect);
$returnmessage = "";
$addreturnmessage = "";

// Determine if a product ID should be passed back to the catalogue/search script...
$item = str_replace("s","",$item);

// Validate variables...
if (isset($item) && !is_numeric($item)) $item = 0;
if (!ashop_is_md5($_COOKIE["customersessionid"])) $_COOKIE["customersessionid"] = "";

// Include language file...
if (!isset($lang) || !preg_match("/[a-z]+/", $lang) || strlen($lang) > 2) $lang = $defaultlanguage;
include "language/$lang/buy.inc.php";

// Connect to database...
$db = @mysql_connect("$databaseserver", "$databaseuser", "$databasepasswd");
@mysql_select_db("$databasename",$db);

// Check bid code if necessary...
$floatingpriceresult = @mysql_query("SELECT * FROM floatingprice WHERE productid='$item'",$db);
if (@mysql_num_rows($floatingpriceresult)) {
	$endprice = @mysql_result($floatingpriceresult,0,"endprice");
	if (!$endprice) $returnmessage = AUCTIONNOTENDED;
	if (!ashop_checkbidcode($db, $_COOKIE["bidderhash"])) $returnmessage = NOTALLOWEDTOBUY;
	$bidderhash = explode("|",$_COOKIE["bidderhash"]);
	$thisbidder = $bidderhash[0];
	if (!ashop_checkfinalbid($db, $thisbidder, $item)) $returnmessage = NOTALLOWEDTOBUY;
	$shoppingcart = "2";
}

// Get customer profile and price level...
if (!empty($_COOKIE["customersessionid"])) {
	$customerresult = @mysql_query("SELECT customerid, level, firstname, lastname FROM customer WHERE sessionid='{$_COOKIE["customersessionid"]}'",$db);
	$pricelevel = @mysql_result($customerresult,0,"level");
	$customerid = @mysql_result($customerresult,0,"customerid");
} else $pricelevel = 0;

// Get the products name and price from the database...
$productresult = @mysql_query("SELECT * FROM product WHERE productid='$item' AND (prodtype!='content' OR prodtype IS NULL)",$db);
$skucode = @mysql_result($productresult, 0, "skucode");
$copyof = @mysql_result($productresult, 0, "copyof");
if (is_numeric($copyof)) $item = $copyof;
$taxmultiplier = 1+($taxpercentage/100);
$taxable = @mysql_result($productresult, 0, "taxable");
if (!$price) {
	if ($pricelevel < 1) $price = @mysql_result($productresult, 0, "price");
	else if ($pricelevel == 1) $price = @mysql_result($productresult, 0, "wholesaleprice");
	else {
		$pricelevels = @mysql_result($productresult, 0, "wspricelevels");
		$pricelevels = explode("|",$pricelevels);
		$price = $pricelevels[$pricelevel-2];
	}
	if ($pricelevel > 0) $displaywithtax = $displaywswithtax;
}
$name = @mysql_result($productresult, 0, "name");
$pricetext = @mysql_result($productresult, 0, "pricetext");
$qtytype = @mysql_result($productresult, 0, "qtytype");
$qtycategory = @mysql_result($productresult, 0, "qtycategory");
$licensetext = @mysql_result($productresult, 0, "licensetext");
$qtylimit = @mysql_result($productresult, 0, "qtylimit");
$qtytlimit = @mysql_result($productresult, 0, "qtytlimit");

// Check if there are enough products in stock for this purchase...
$useinventory = @mysql_result($productresult, 0, "useinventory");
if ($useinventory) {
	$checksaasuinventory = "";
	if ($saasuwsaccesskey && $saasufileid) {
		$checksaasuinventory = ashop_saasu_getinventory($skucode);
		if ($checksaasuinventory != "nodata") {
			$inventory = $checksaasuinventory;
			@mysql_query("UPDATE product SET inventory = '$inventory' WHERE productid='$item'",$db);
		} else $inventory = @mysql_result($productresult, 0, "inventory");
	} else $inventory = @mysql_result($productresult, 0, "inventory");

	$basket = ashop_combineproducts($basket);
	$alreadyincart = ashop_checkproduct($item, $basket, "");

	if (!$inventory) {
		$returnmessage = OUTOFSTOCK;
	} else if ($inventory < ($quantity+$alreadyincart)) {
		$quantity = $inventory - $alreadyincart;
		if ($inventory == $alreadyincart) {
			$quantity = 0;
			$returnmessage = NOTENOUGHINSTOCK;
		} else $addreturnmessage = NOTTHATMANYINSTOCK;			
	}
}

// Check if the product uses qty based pricing...
$qtypriceresult = @mysql_query("SELECT * FROM qtypricelevels WHERE productid='$item'",$db);
$qtypricing = @mysql_num_rows($qtypriceresult);

// Get parameters for this product...
$sql = "SELECT * FROM parameters WHERE productid='$item' ORDER BY parameterid";
$paramresult = @mysql_query("$sql",$db);
$checkparams = TRUE;
while ($paramrow = @mysql_fetch_array($paramresult)) if (!$paramrow["buybuttons"]) $checkparams = FALSE;

// Get sale for this product...
$discountresult = @mysql_query("SELECT * FROM discount WHERE productid='$item' AND onetime='0' AND (code='' OR code IS NULL)",$db);
if (@mysql_num_rows($discountresult)) {
	$salediscount = TRUE;
	$salediscountid = @mysql_result($discountresult,0,"discountid");
} else $salediscount = FALSE;

/* Apply referral discounts...
if (!empty($affiliate)) {
	$discountresult = @mysql_query("SELECT discount.* FROM discount,referraldiscount WHERE referraldiscount.affiliateid='$affiliate' AND referraldiscount.code=discount.code AND discount.productid='$item'",$db);
	if (@mysql_num_rows($discountresult)) {
		$affiliatediscount = TRUE;
		$discountcode = @mysql_result($discountresult,0,"code");
		$salediscountid = @mysql_result($discountresult,0,"discountid");
	} else $affiliatediscount = FALSE;
} else $affiliatediscount = FALSE;*/
 
// Check if single quantity mode is being used...
if ($shoppingcart == "2") if (ashop_checkproduct($item, $basket, "")) $returnmessage = ALREADYINCART;

// Get any parameter values and store in basket cookiestring...
$parameterstring = "";
$type = "";
if (@mysql_num_rows($paramresult)) {
	for ($i = 0; $i < @mysql_num_rows($paramresult); $i++) {
		$parameterid = @mysql_result($paramresult, $i, "parameterid");
		$parametername = strtolower(@mysql_result($paramresult, $i, "caption"));
		$subresult = @mysql_query("SELECT valueid FROM parametervalues WHERE parameterid='$parameterid'", $db);
		if (@mysql_num_rows($subresult) == 1) $thisparameter = @mysql_result($subresult, 0, "valueid");
		else eval ("\$thisparameter = \$attribute$parameterid;");
		$subresult = @mysql_query("SELECT * FROM parametervalues WHERE parameterid='$parameterid' AND valueid='$thisparameter'", $db);
		if (!@mysql_num_rows($subresult)) {
			$parameterfiltername = str_replace(" ","",$parametername);
			if (file_exists("$ashoppath/admin/filters/$parameterfiltername.inc.php")) {
				$filter_attributeid = $parameterid;
				$filter_attributename = @mysql_result($paramresult, $i, "caption");
				$filter_productid = $item;
				$filter_attributevalue = $thisparameter;
				include "$ashoppath/admin/filters/$parameterfiltername.inc.php";
				$parameterid = $filter_attributeid;
				$item = $filter_productid;
				$thisparameter = $filter_attributevalue;
			}
			$now = time()+$timezoneoffset;
			$thisparameter = str_replace("'","&#39;",$thisparameter);
			$thisparameter = str_replace("\"","&quot;",$thisparameter);
			@mysql_query("INSERT INTO customparametervalues (parameterid, value, timestamp) VALUES ('$parameterid', '$thisparameter', '$now')", $db);
			if (@mysql_affected_rows($db) == 1) $thisparameter = @mysql_insert_id();
		} else {
			$type .= $thisparameter."|";
			$attributeprice = @mysql_result($subresult, 0, "price");
			if ($attributeprice) {
				$thisparameterprices = explode("|",$attributeprice);
				$price = $thisparameterprices[$pricelevel];
			}
		}
		$parameterstring .= $thisparameter."b";
	}
}

// Check the inventory status of this type of the product...
if ($useinventory) {
	if ($type) $type = substr($type,0,-1);
	$typeinventoryresult = @mysql_query("SELECT inventory FROM productinventory WHERE productid='$item' AND type='$type'",$db);
	if (@mysql_num_rows($typeinventoryresult)) {
		$typeinventory = @mysql_result($typeinventoryresult,0,"inventory");
		if (!$typeinventory) $returnmessage = OUTOFSTOCK;
		if ($typeinventory < $quantity) $returnmessage = NOTENOUGHINSTOCK;
	}
}

// Check if this customer is allowed to buy this many items...
if (!empty($qtylimit) && $qtylimit > 0) {
	if (!$useinventory) {
		$basket = ashop_combineproducts($basket);
		$alreadyincart = ashop_checkproduct($item, $basket, "");
	}
	if (empty($customerid)) $returnmessage = MUSTLOGIN;
	else if ($alreadyincart == $qtylimit) $returnmessage = NOTALLOWEDQTY;
	// Check if this customer has already bought this item before...
	else {
		$previouslybought = 0;
		$checkproductstring = "b".$item."a";
		$previouspurchaseresult = @mysql_query("SELECT products FROM orders WHERE date IS NOT NULL AND date != '' AND products LIKE '%$checkproductstring%' AND customerid='$customerid'",$db);
		while ($previouspurchaserow = @mysql_fetch_array($previouspurchaseresult)) {
			$previouspurchaseproducts = $previouspurchaserow["products"];
			$previouslybought += ashop_checkproduct($item, $previouspurchaseproducts, "");
		}
		if ($quantity+$alreadyincart+$previouslybought > $qtylimit) {
			if ($alreadyincart+$previouslybought == $qtylimit) $returnmessage = NOTALLOWEDQTY;
			else {
				$quantity = $qtylimit-$alreadyincart-$previouslybought;
				$addreturnmessage = NOTALLOWEDQTY;
			}
		}
	}
}
if (!empty($qtytlimit) && $qtytlimit > 0) {
	if (!$useinventory) {
		$basket = ashop_combineproducts($basket);
		$alreadyincart = ashop_checkproduct($item, $basket, "");
	}
	if ($quantity+$alreadyincart > $qtytlimit) {
		if ($alreadyincart == $qtytlimit) $returnmessage = NOTALLOWEDQTY;
		else {
			$quantity = $qtytlimit-$alreadyincart;
			$addreturnmessage = NOTALLOWEDQTY;
		}
	}
}


// Store discount...
if ($salediscount) {
	$discountcookiestring = md5($item."ashopdiscounts");
	if (!$p3psent) header('P3P: CP="IDC DSP COR CURa ADMa OUR IND PHY ONL COM STA"');
	$p3psent = TRUE;
	setcookie("discount$salediscountid", $discountcookiestring);
} else if ($affiliatediscount) {
	$discountcookiestring = md5($item.$discountcode."ashopdiscounts");
	if (!$p3psent) header('P3P: CP="IDC DSP COR CURa ADMa OUR IND PHY ONL COM STA"');
	$p3psent = TRUE;
	setcookie("discount$salediscountid", $discountcookiestring);
}

if (empty($returnmessage)) {
	$oldqty = ashop_getquantity($item, $basket);
	// Calculate current subtotal of quantity pricing items...
	if ($qtytype == "1" || $qtytype == "2" || $qtytype == "3" || $qtytype == "4") {
		if ($qtytype == "1" || $qtytype == "3") $subtotalqty = $oldqty;
		else {
			if ($qtycategory) $subtotalqty = ashop_categoryqty($db, $basket, $qtycategory);
			else $subtotalqty = ashop_totalqty("$basket");
		}
		$oldsubtotal = ashop_subtotal($db, $item, $subtotalqty, $oldqty, $discountcookiestring, $price, $qtytype);
	} else $oldsubtotal = 0;
	// Calculate new subtotal of quantity pricing items...
	if ($qtytype == "1" || $qtytype == "2" || $qtytype == "3" || $qtytype == "4") {
		if (!$qtytype || $qtytype == "1" || $qtytype == "3") $subtotalqty = $oldqty+$quantity;
		else {
			if ($qtycategory) $subtotalqty = ashop_categoryqty($db, $basket, $qtycategory)+$quantity;
			else $subtotalqty = ashop_totalqty("$basket")+$quantity;
		}
		$subtotal = ashop_subtotal($db, $item, $subtotalqty, $oldqty+$quantity, $discountcookiestring, $price, $qtytype);
	} else {
		$subtotalqty = $oldqty+$quantity;
		$subtotal = ashop_subtotal($db, $item, $subtotalqty, $quantity, $discountcookiestring, $price, $qtytype);
	}
	if ($taxable && $displaywithtax == 1) $subtotal = $subtotal*$taxmultiplier;
	$currenttotal = str_replace($thousandchar,"",$currenttotal);
	$currenttotal = str_replace($decimalchar,".",$currenttotal);
	if (!is_numeric($currenttotal)) $currenttotal = 0;
	// Get currency rate if needed...
	if (isset($curr) && preg_match("/^[a-z]*$/", $curr) && strlen($curr) == 3 && $curr != $ashopcurrency) {
		$crate = getcurrency($curr);
		$subtotal = $subtotal*$crate;
	}
	$subtotal += $currenttotal;
	$subtotal -= $oldsubtotal;
	$subtotal = number_format($subtotal,$showdecimals,$decimalchar,$thousandchar);
} else $subtotal = $currenttotal;

if (empty($returnmessage)) {
	if (!$p3psent) header('P3P: CP="IDC DSP COR CURa ADMa OUR IND PHY ONL COM STA"');
	$p3psent = TRUE;
	setcookie("basket","$basket$quantity"."b"."$parameterstring$item"."a");
	$name = str_replace("'", "&#039;", $name);
	if ($redirect) header("Location: $redirect");
	else {
		header('Content-type: text/plain');
		if (!empty($addreturnmessage)) echo "$subtotal|$addreturnmessage";
		else echo "$subtotal|$quantity $name ".HASBEENADDED;
	}
} else {
	$returnurl = $_SERVER["HTTP_REFERER"];
	$returnurl = str_replace($ashopurl."/","",$returnurl);
	$returnurl = str_replace($ashopsurl."/","",$returnurl);
	if ($redirect) header("Location: $redirect?msg=$returnmessage&returnurl=$returnurl");
	else {
		header('Content-type: text/plain');
		echo "$subtotal|$returnmessage";
	}
}
?>