<?php
// AShop
// Copyright 2011 - AShop Software - http://www.ashopsoftware.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see: http://www.gnu.org/licenses/.

unset($shop);
unset($userid);
include "admin/config.inc.php";
include "admin/ashopfunc.inc.php";
include "admin/ashopconstants.inc.php";

// Apply selected theme...
$templatepath = "/templates";
if ($ashoptheme && $ashoptheme != "none" && file_exists("$ashoppath/themes/$ashoptheme/theme.cfg.php")) include "themes/$ashoptheme/theme.cfg.php";
if ($usethemetemplates == "true") $templatepath = "/themes/$ashoptheme";
if ($lang && is_array($themelanguages)) {
	if (!in_array("$lang",$themelanguages)) unset($lang);
}

// Include language file...
if (!isset($lang) || !preg_match("/[a-z]+/", $lang) || strlen($lang) > 2) $lang = $defaultlanguage;
include "language/$lang/download.inc.php";

if ($dorefresh == "true") {
	echo "<html><head><meta http-equiv=\"refresh\" content=\"0;URL=$ashopurl/download.php?$filename\"><style type=\"text/css\"><!-- .fontsize1 { font-size: {$fontsize1}px}\n.fontsize2 { font-size: {$fontsize2}px}\n.fontsize3 { font-size: {$fontsize3}px}--></style></head><body bgcolor=\"$bgcolor\" text=\"$textcolor\" link=\"$linkcolor\" alink=\"$linkcolor\" vlink=\"$linkcolor\"><center>
		<p><img src=\"images/logo.gif\"></p>
        <font face=\"$font\"><span class=\"fontsize2\"><p><b>".WAIT."</b></p>
		<p><a href=\"javascript:history.back()\">".BACK."</a></p>
        </span></font></center></body></html>";
	exit;
}
$nfile = $fileid;
$updatefile = $fileid;
$npassword = $password;
$nemail = $email;
if (!$p3psent) header('P3P: CP="IDC DSP COR CURa ADMa OUR IND PHY ONL COM STA"');
$p3psent = TRUE;
setcookie("fileid","");
setcookie("password","");
setcookie("email","");

// Open database...
$db = @mysql_connect("$databaseserver", "$databaseuser", "$databasepasswd");
@mysql_select_db("$databasename",$db);

// Set date for logging...
$date = date("Y-m-d", time()+$timezoneoffset);

// Check login information...
if ((!$npassword || !$nfile || !$nemail) && !$notallowed) {
	if ($lang != $defaultlanguage && file_exists("$ashoppath$templatepath/delivery-$lang.html")) ashop_showtemplateheader("$ashoppath$templatepath/delivery-$lang.html");
	else ashop_showtemplateheader("$ashoppath$templatepath/delivery.html");
	echo "<table class=\"ashopmessagetable\" align=\"center\">
	<tr align=\"center\"><td><br><br><p><span class=\"ashopmessageheader\">".NOACCESS."</span></p>
	<p><span class=\"ashopmessage\">".LOGIN."</span></p>
	<p><span class=\"ashopmessage\"><a href=\"deliver.php\">".CLICK."</a></span></p></td></tr></table>";
	if ($lang != $defaultlanguage && file_exists("$ashoppath$templatepath/delivery-$lang.html")) ashop_showtemplatefooter("$ashoppath$templatepath/delivery-$lang.html");
	else ashop_showtemplatefooter("$ashoppath$templatepath/delivery.html");
	exit;
}

// Get the productid and fileid for the file...
$result = @mysql_query("SELECT * FROM productfiles WHERE id='$nfile'",$db);
$nproduct = @mysql_result($result, 0, "productid");
$nfile = @mysql_result($result, 0, "fileid");
$nurl = @mysql_result($result, 0, "url");

$isupdate == "false";
$sql="SELECT orders.*, customer.firstname, customer.lastname FROM customer, orders WHERE orders.password='$npassword' AND (customer.email='$nemail' OR customer.alternativeemails LIKE '%$nemail%') AND orders.customerid=customer.customerid";
$result = @mysql_query("$sql",$db);
if (!$notallowed && @mysql_num_rows($result) == 0) {
	$nfile = $updatefile;
	$sql = "SELECT * FROM updates WHERE password='$npassword' AND productid='$nfile'";
	$result2 = @mysql_query("$sql",$db);
	if (@mysql_num_rows($result2) == 0 || !$nemail) {
		if ($lang != $defaultlanguage && file_exists("$ashoppath$templatepath/delivery-$lang.html")) ashop_showtemplateheader("$ashoppath$templatepath/delivery-$lang.html");
		else ashop_showtemplateheader("$ashoppath$templatepath/delivery.html");
		echo "<table class=\"ashopmessagetable\" align=\"center\">
		<tr align=\"center\"><td><br><br><p><span class=\"ashopmessageheader\">".WRONGPASSWORD."</span></p>
		<p><span class=\"ashopmessage\"><a href=\"javascript:history.back()\">".TRYAGAIN."</a></span></p></td></tr></table>";
		if ($lang != $defaultlanguage && file_exists("$ashoppath$templatepath/delivery-$lang.html")) ashop_showtemplatefooter("$ashoppath$templatepath/delivery-$lang.html");
		else ashop_showtemplatefooter("$ashoppath$templatepath/delivery.html");
		exit;
	} else {
		$isupdate = "true";
		$alloweddownloaddays = @mysql_result($result2, 0, "alloweddays");
	}
} else {
	$allowedproduct = "FALSE";
	$allowedproducts = ashop_parseproductstring($db, @mysql_result($result, 0, "products"));
	if ($allowedproducts) foreach($allowedproducts as $productnumber => $thisproduct) if ($thisproduct["productid"] == $nproduct) $allowedproduct = "TRUE";
	if ($allowedproduct != "TRUE") {
		if ($lang != $defaultlanguage && file_exists("$ashoppath$templatepath/delivery-$lang.html")) ashop_showtemplateheader("$ashoppath$templatepath/delivery-$lang.html");
		else ashop_showtemplateheader("$ashoppath$templatepath/delivery.html");
		echo "<table class=\"ashopmessagetable\" align=\"center\">
		<tr align=\"center\"><td><br><br><p><span class=\"ashopmessageheader\"><b>".NOTALLOW."</b><br>".AUTOREPORT."</span></p></td></tr></table>";
		if ($lang != $defaultlanguage && file_exists("$ashoppath$templatepath/delivery-$lang.html")) ashop_showtemplatefooter("$ashoppath$templatepath/delivery-$lang.html");
		else ashop_showtemplatefooter("$ashoppath$templatepath/delivery.html");
		$headers = "From: ".un_html($ashopname)."<$ashopemail>\nX-Sender: <$ashopemail>\nX-Mailer: PHP\nX-Priority: 3\nReturn-Path: <$ashopemail>\nMIME-Version: 1.0\nContent-Type: text/html; charset=iso-8859-1\n";
		@ashop_mail("$ashopemail",un_html($ashopname)." - suspected delivery manipulation","Suspected delivery manipulation: the customer with this email address: $nemail has tried to access the product with ID: $nproduct with an unauthorized password from IP: {$_SERVER["REMOTE_ADDR"]}!","$headers");
		exit;
	}
}

// Check if this is a gift...
$description = explode("|",@mysql_result($result,0,"description"));
if ($description[0] == "gift") {
	$isgift = "true";
	$giftdate = date("Y-m-d H:i:s", $description[1]);
}

// Check allowed download time and downloads per product...
if ($isupdate != "true") {
	$orderid = @mysql_result($result, 0, "orderid");
	$firstname = @mysql_result($result, 0, "firstname");
	$lastname = @mysql_result($result, 0, "lastname");
	$userid = @mysql_result($result, 0, "userid");
	if ($userid && $userid != "|1|") {
		$fileresult = @mysql_query("SELECT product.userid FROM product, productfiles WHERE productfiles.fileid='$nfile' AND productfiles.productid=product.productid",$db);
		$userid = @mysql_result($fileresult, 0, "userid");
		$shopresult = @mysql_query("SELECT * FROM user WHERE userid='$userid'",$db);
		$shoprow = @mysql_fetch_array($result);
		$membershopemail = $row["email"];
		$membershopname = $row["firstname"]." ".$row["lastname"];
	}
	$downloadsresult = @mysql_query("SELECT * FROM orderdownloads WHERE fileid='$nfile' AND orderid='$orderid'",$db);
	$downloads = @mysql_result($downloadsresult, 0, "downloads")+1;

	// Log this download...
	$ipnumber = $_SERVER["REMOTE_ADDR"];
	if (!ashop_is_ip($ipnumber)) $ipnumber = "Unknown";
	@mysql_query("INSERT INTO downloadslog (fileid, orderid, date, ip) VALUES ('$nfile', '$orderid', '$date', '$ipnumber')",$db);

	if (($downloads > $alloweddownloads && $alloweddownloads) || $notallowed) {
		if ($lang != $defaultlanguage && file_exists("$ashoppath$templatepath/delivery-$lang.html")) ashop_showtemplateheader("$ashoppath$templatepath/delivery-$lang.html");
		else ashop_showtemplateheader("$ashoppath$templatepath/delivery.html");
		echo "<table class=\"ashopmessagetable\" align=\"center\">
		<tr align=\"center\"><td><br><br><p><span class=\"ashopmessageheader\">".ALREADY."</span></p>
		<p><span class=\"ashopmessage\"><a href=\"javascript:history.back()\">".BACK."</a></span></p></td></tr></table>";
		if ($lang != $defaultlanguage && file_exists("$ashoppath$templatepath/delivery-$lang.html")) ashop_showtemplatefooter("$ashoppath$templatepath/delivery-$lang.html");
		else ashop_showtemplatefooter("$ashoppath$templatepath/delivery.html");
		exit;
	} else {
		if (@mysql_num_rows($downloadsresult)) @mysql_query("UPDATE orderdownloads SET downloads='$downloads' WHERE orderid='$orderid' AND fileid='$nfile'",$db);
		else @mysql_query("INSERT INTO orderdownloads (downloads, orderid, fileid) VALUES ('$downloads','$orderid','$nfile')",$db);
	}
}
if ($alloweddownloaddays) {
	$payoption = @mysql_result($result, 0, "payoptionid");
	$result4 = @mysql_query("SELECT deliverpending FROM payoptions WHERE payoptionid='$payoption'",$db);
	$deliverpending = @mysql_result($result4, 0, "deliverpending");
	if ($isgift == "true") $orderdate = explode(" ",$giftdate);
	else if ($isupdate != "true" && $deliverpending) $orderdate = explode(" ",@mysql_result($result, 0, "date"));
	else if ($isupdate != "true") $orderdate = explode(" ",@mysql_result($result, 0, "paid"));
	else $orderdate = explode(" ",@mysql_result($result2, 0, "date"));
	$orderdate = explode ("-",$orderdate[0]);
	$orderedtimestamp = mktime(0,0,0,$orderdate[1],$orderdate[2],$orderdate[0]);
	if ((floor((time()+$timezoneoffset)/86400))*86400 - $orderedtimestamp > 86400 * ($alloweddownloaddays+1)) {
		if ($lang != $defaultlanguage && file_exists("$ashoppath$templatepath/delivery-$lang.html")) ashop_showtemplateheader("$ashoppath$templatepath/delivery-$lang.html");
		else ashop_showtemplateheader("$ashoppath$templatepath/delivery.html");
		echo "<table class=\"ashopmessagetable\" align=\"center\">
		<tr align=\"center\"><td><br><br><p><span class=\"ashopmessageheader\">".TIMEEXPIRED."</span></p>
		<p><span class=\"ashopmessage\"><a href=\"javascript:history.back()\">".BACK."</a></span></p></td></tr></table>";
		if ($lang != $defaultlanguage && file_exists("$ashoppath$templatepath/delivery-$lang.html")) ashop_showtemplatefooter("$ashoppath$templatepath/delivery-$lang.html");
		else ashop_showtemplatefooter("$ashoppath$templatepath/delivery.html");
		exit;
	}
}

// Start download...
if ($nfile && $isupdate != "true") {
	$message = "<html><head><title>$ashopname- Delivery</title>\n<style type=\"text/css\"><!-- .fontsize1 { font-size: {$fontsize1}px}\n.fontsize2 { font-size: {$fontsize2}px}\n.fontsize3 { font-size: {$fontsize3}px}--></style></head><body><font face=\"$font\"><span class=\"fontsize2\"><p>$firstname $lastname downloaded {$_SERVER["QUERY_STRING"]} $date from: {$_SERVER["REMOTE_ADDR"]}</p></span></font></body></html>";
	$headers = "From: $firstname $lastname<$email>\nX-Sender: <$email>\nX-Mailer: PHP\nX-Priority: 3\nReturn-Path: <$email>\nMIME-Version: 1.0\nContent-Type: text/html; charset=iso-8859-1\n";
	@ashop_mail("$ashopemail",un_html($ashopname)." - delivery","$message","$headers");
	if ($membershopemail) @ashop_mail("$membershopemail",un_html($membershopname)." - delivery","$message","$headers");
	if ($downloadsavedialogue == "on") {
		header ("Content-Type: application/octet-stream"); 
		if (!$nurl) header ("Content-Length: ".filesize("$ashopspath/products/$nfile"));
		header ("Content-Disposition: attachment; filename={$_SERVER["QUERY_STRING"]}");
	} else {
		$fileinfo = pathinfo("{$_SERVER["QUERY_STRING"]}");
	    $extension = strtolower($fileinfo["extension"]);
		$mimetype = $mimetypes["$extension"];
		if (!$mimetype) $mimetype = "application/octet-stream";
		header ("Content-Type: $mimetype");
		if (!$nurl) header ("Content-Length: ".filesize("$ashopspath/products/$nfile"));
	}
	if ($nurl) {
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL,$nurl);
		curl_setopt($ch, CURLOPT_POST, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 0);
		curl_exec ($ch);
	} else readfile_chunked("$ashopspath/products/$nfile",false);
} else if ($nfile && $isupdate == "true") {
	$message = "<html><head><title>$ashopname - Update delivery</title>\n<style type=\"text/css\"><!-- .fontsize1 { font-size: {$fontsize1}px}\n.fontsize2 { font-size: {$fontsize2}px}\n.fontsize3 { font-size: {$fontsize3}px}--></style></head><body><font face=\"$font\"><span class=\"fontsize2\"><p>A customer with the email address $email downloaded the update {$_SERVER["QUERY_STRING"]} $date from: {$_SERVER["REMOTE_ADDR"]}</p></span></font></body></html>";
	$headers = "From: $firstname $lastname<$email>\nX-Sender: <$email>\nX-Mailer: PHP\nX-Priority: 3\nReturn-Path: <$email>\nMIME-Version: 1.0\nContent-Type: text/html; charset=iso-8859-1\n";
	@ashop_mail("$ashopemail",un_html($ashopname)." - delivery","$message","$headers");
	header ("Content-Type: application/octet-stream"); 
	header ("Content-Length: ".filesize("$ashopspath/updates/$nfile"));
	header ("Content-Disposition: attachment; filename={$_SERVER["QUERY_STRING"]}");
	readfile_chunked("$ashopspath/updates/$nfile",false);
} else {
	if ($lang != $defaultlanguage && file_exists("$ashoppath$templatepath/delivery-$lang.html")) ashop_showtemplateheader("$ashoppath$templatepath/delivery-$lang.html");
	else ashop_showtemplateheader("$ashoppath$templatepath/delivery.html");
	echo "<table class=\"ashopmessagetable\" align=\"center\">
	<tr align=\"center\"><td><br><br><p><span class=\"ashopmessageheader\">".ERROR."</span></p>
	<p><span class=\"ashopmessage\">".COULDNOTDOWNLOAD."</span></p>
	<p><span class=\"ashopmessage\"><a href=\"javascript:history.back()\">".TRYAGAIN."</a></span></p></td></tr></table>";
	if ($lang != $defaultlanguage && file_exists("$ashoppath$templatepath/delivery-$lang.html")) ashop_showtemplatefooter("$ashoppath$templatepath/delivery-$lang.html");
	else ashop_showtemplatefooter("$ashoppath$templatepath/delivery.html");
	exit;
}
?>